#ifdef VMS	/* In case it gets compiled somewhere else... */

#include	<stdio.h>
#include	<ssdef.h>
#include	<fscndef.h>
#include	<string.h>

static struct {
    char	*what;
    int		item;
} items[] = { "node", FSCN$_NODE,
	      "device", FSCN$_DEVICE,
	      "directory", FSCN$_DIRECTORY,
	      "filename", FSCN$_NAME,
	      "name", FSCN$_NAME,
	      "type", FSCN$_TYPE,
	      "extension", FSCN$_TYPE,
	      "version", FSCN$_VERSION,
	      NULL, 0
	    };

Tcl_VmsParseFileName(char *file, char *what, char *result)
{
    /*
	Return one piece from a DEC filename
    */
    char		
    int			status, flags;
    int			n;
    struct _fscn {
	short	length;
	short	item;
	char	*address;
    } ss[2];
    struct {
	int	l;
	char	*a;
    } d;

    ss[0].item = 0;
    for (n=0; items[n].what; n++) {
	if (strstr(items[n].what, what) == items[n].what) {
	    ss[0].item = items[n].item;
	    break;
	}
    }
    if (ss[0].item == 0)
	return(0);
    ss[1].length = ss[1].item = 0;
    d.l = strlen(file);
    d.a = file;
    status = sys$filescan(&d, &ss, &flags);
    if (status == SS$_NORMAL) {
	n = ss[0].length;
	if (n)
	    strncpy(result, ss[0].address, n);
	result[n] = 0;
	status = 1;
    }
    else
	status = 0;
    return status;
}

static void	actionRoutine(char *);
static char	*whereToCopy;

Tcl_Cvt2Vms(char *unixName, char *vmsName)
{
    /*
	Convert a Unix filename to VMS
    */
    whereToCopy = vmsName;
    if (shell$to_vms(unixName, actionRoutine, 0))
	return 1;
    else
	return 0;
}

static void
actionRoutine(char *s)
{
    strcpy(whereToCopy, s);
}
#endif	/* VMS */
